package org.example;

import jakarta.jms.JMSException;
import jakarta.jms.Message;
import jakarta.jms.TextMessage;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Component;

@Component
public class ChatListener {

	@JmsListener(destination = "${chat.topic}", selector = "user <> '${chat.user}'")
	public void onMessage(Message message) {
		if (message instanceof TextMessage) {
			try {
				String sender = message.getStringProperty("user");
				String text = ((TextMessage) message).getText();
				if (sender != null && text != null) {
					System.out.println(sender + ": " + text);
				}
			} catch (JMSException ex) {
				System.out.println("--- Error: " + ex.getMessage());
			}
		}
	}
}
